var buildBuffer;
buildBuffer = function() {
  var a, buffer, format, length, offset, value, _i, _len, _ref, _step;
  if (arguments.length % 2 !== 0) {
    throw new Error("Expected pairs of arguments, but have " + arguments.length + " arguments");
  }
  length = 0;
  for (_i = 0, _len = arguments.length, _step = 2; _i < _len; _i += _step) {
    format = arguments[_i];
    switch (format) {
      case '8':
      case 'U8':
        length += 1;
        break;
      case '16':
      case '16L':
      case 'U16':
      case 'U16L':
        length += 2;
        break;
      case '32':
      case '32L':
      case 'U32':
      case 'U32L':
        length += 4;
        break;
      default:
        throw new Error("Format '" + format + "' not recognised");
    }
  }
  buffer = new Buffer(length);
  offset = 0;
  for (a = 0, _ref = arguments.length - 1; a <= _ref; a += 2) {
    format = arguments[a];
    value = arguments[a + 1];
    switch (format) {
      case '8':
        buffer.writeInt8(value, offset);
        offset += 1;
        break;
      case 'U8':
        buffer.writeUInt8(value, offset);
        offset += 1;
        break;
      case '16':
        buffer.writeInt16BE(value, offset);
        offset += 2;
        break;
      case '16L':
        buffer.writeInt16LE(value, offset);
        offset += 2;
        break;
      case 'U16':
        buffer.writeUInt16BE(value, offset);
        offset += 2;
        break;
      case 'U16L':
        buffer.writeUInt16LE(value, offset);
        offset += 2;
        break;
      case '32':
        buffer.writeInt32BE(value, offset);
        offset += 4;
        break;
      case '32L':
        buffer.writeInt32LE(value, offset);
        offset += 4;
        break;
      case 'U32':
        buffer.writeUInt32BE(value, offset);
        offset += 4;
        break;
      case 'U32L':
        buffer.writeUInt32LE(value, offset);
        offset += 4;
        break;
      default:
        throw new Error("Format '" + format + "' not recognised");
    }
  }
  return buffer;
};
module.exports = buildBuffer;