var errorParser, infoParser, parser;
parser = function(buffer, position) {
  var class_, length, lineNumber, message, number, procName, serverName, state, token, valueLength;
  if (buffer.length - position < 3) {
    return false;
  }
  length = buffer.readUInt16LE(position);
  position += 2;
  if (buffer.length - position < length) {
    return false;
  }
  number = buffer.readUInt32LE(position);
  position += 4;
  state = buffer.readUInt8(position);
  position++;
  class_ = buffer.readUInt8(position);
  position++;
  valueLength = buffer.readUInt16LE(position) * 2;
  position += 2;
  message = buffer.toString('ucs-2', position, position + valueLength);
  position += valueLength;
  valueLength = buffer.readUInt8(position) * 2;
  position++;
  serverName = buffer.toString('ucs-2', position, position + valueLength);
  position += valueLength;
  valueLength = buffer.readUInt8(position) * 2;
  position++;
  procName = buffer.toString('ucs-2', position, position + valueLength);
  position += valueLength;
  lineNumber = buffer.readUInt32LE(position);
  position += 4;
  return token = {
    length: length + 2,
    number: number,
    state: state,
    "class": class_,
    message: message,
    serverName: serverName,
    procName: procName,
    lineNumber: lineNumber
  };
};
infoParser = function(buffer, position) {
  var token;
  token = parser(buffer, position);
  token.name = 'INFO';
  token.event = 'infoMessage';
  return token;
};
errorParser = function(buffer, position) {
  var token;
  token = parser(buffer, position);
  token.name = 'ERROR';
  token.event = 'errorMessage';
  return token;
};
exports.infoParser = infoParser;
exports.errorParser = errorParser;