var interfaces, parser, versions;
versions = require('../tds-versions').versionsByValue;
interfaces = {
  0: 'SQL_DFLT',
  1: 'SQL_TSQL'
};
parser = function(buffer, position) {
  var error, interface, interfaceNumber, length, progName, progVersion, tdsVersion, tdsVersionNumber, token, valueLength;
  if (buffer.length - position < 3) {
    return false;
  }
  length = buffer.readUInt16LE(position);
  position += 2;
  if (buffer.length - position < length) {
    return false;
  }
  interfaceNumber = buffer.readUInt8(position);
  interface = interfaces[interfaceNumber];
  if (!interface) {
    error = "Unknown LOGINACK Interface " + interfaceNumber + " at offset " + position;
  }
  position++;
  tdsVersionNumber = buffer.readUInt32BE(position);
  tdsVersion = versions[tdsVersionNumber];
  if (!tdsVersion) {
    error = "Unknown LOGINACK TDSVersion " + tdsVersionNumber + " at offset " + position;
  }
  position += 4;
  valueLength = buffer.readUInt8(position) * 2;
  position++;
  progName = buffer.toString('ucs-2', position, position + valueLength);
  position += valueLength;
  progVersion = {
    major: buffer.readUInt8(position++),
    minor: buffer.readUInt8(position++),
    buildNumHi: buffer.readUInt8(position++),
    buildNumLow: buffer.readUInt8(position++)
  };
  if (error) {
    return token = {
      name: 'LOGINACK',
      error: error
    };
  } else {
    return token = {
      name: 'LOGINACK',
      length: length + 2,
      event: 'loginack',
      interface: interface,
      tdsVersion: tdsVersion,
      progName: progName,
      progVersion: progVersion
    };
  }
};
module.exports = parser;