var Debug, Parser, TYPE, createDbChangeBuffer, debug;
Debug = require('../../../lib/debug');
Parser = require('../../../lib/token/token-stream-parser').Parser;
TYPE = require('../../../lib/token/token').TYPE;
debug = new Debug({
  token: true
});
module.exports.envChange = function(test) {
  var buffer, parser;
  buffer = createDbChangeBuffer();
  parser = new Parser(debug);
  parser.addBuffer(buffer);
  test.ok(parser.end());
  return test.done();
};
module.exports.tokenSplitAcrossBuffers = function(test) {
  var buffer, parser;
  buffer = createDbChangeBuffer();
  parser = new Parser(debug);
  parser.addBuffer(buffer.slice(0, 6));
  parser.addBuffer(buffer.slice(6));
  test.ok(parser.end());
  return test.done();
};
createDbChangeBuffer = function() {
  var buffer, newDb, oldDb, pos;
  oldDb = 'old';
  newDb = 'new';
  buffer = new Buffer(1 + 2 + 1 + 1 + (oldDb.length * 2) + 1 + (newDb.length * 2));
  pos = 0;
  buffer.writeUInt8(TYPE.ENVCHANGE, pos);
  pos++;
  buffer.writeUInt16LE(buffer.length - (1 + 2), pos);
  pos += 2;
  buffer.writeUInt8(0x01, pos);
  pos++;
  buffer.writeUInt8(oldDb.length, pos);
  pos++;
  buffer.write(oldDb, pos, 'ucs-2');
  pos += oldDb.length * 2;
  buffer.writeUInt8(newDb.length, pos);
  pos++;
  buffer.write(newDb, pos, 'ucs-2');
  pos += newDb.length * 2;
  return buffer;
};